<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11.0.9) on Wed Oct 28 16:08:51 UTC 2020 -->
<title>mxUndoManager (JGraph X 4.2.2 API Specification)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-10-28">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../script.js"></script>
<script type="text/javascript" src="../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../jquery/jquery-3.5.1.js"></script>
<script type="text/javascript" src="../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="mxUndoManager (JGraph X 4.2.2 API Specification)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxUndoManager.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">hk.quantr.mxgraph.util</a></div>
<h2 title="Class mxUndoManager" class="title">Class mxUndoManager</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li><a href="mxEventSource.html" title="class in hk.quantr.mxgraph.util">hk.quantr.mxgraph.util.mxEventSource</a></li>
<li>
<ul class="inheritance">
<li>hk.quantr.mxgraph.util.mxUndoManager</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">mxUndoManager</span>
extends <a href="mxEventSource.html" title="class in hk.quantr.mxgraph.util">mxEventSource</a></pre>
<div class="block">Implements an undo history.
 
 This class fires the following events:
 
 mxEvent.CLEAR fires after clear was executed. The event has no properties.
 
 mxEvent.UNDO fires afer a significant edit was undone in undo. The
 <code>edit</code> property contains the mxUndoableEdit that was undone.
 
 mxEvent.REDO fires afer a significant edit was redone in redo. The
 <code>edit</code> property contains the mxUndoableEdit that was redone.
 
 mxEvent.ADD fires after an undoable edit was added to the history. The
 <code>edit</code> property contains the mxUndoableEdit that was added.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="nested.class.summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<ul class="blockList">
<li class="blockList"><a id="nested.classes.inherited.from.class.hk.quantr.mxgraph.util.mxEventSource">
<!--   -->
</a>
<h3>Nested classes/interfaces inherited from class&nbsp;hk.quantr.mxgraph.util.<a href="mxEventSource.html" title="class in hk.quantr.mxgraph.util">mxEventSource</a></h3>
<code><a href="mxEventSource.mxIEventListener.html" title="interface in hk.quantr.mxgraph.util">mxEventSource.mxIEventListener</a></code></li>
</ul>
</li>
</ul>
</section>
<!-- =========== FIELD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Field</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.util.List&lt;<a href="mxUndoableEdit.html" title="class in hk.quantr.mxgraph.util">mxUndoableEdit</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#history">history</a></span></code></th>
<td class="colLast">
<div class="block">List that contains the steps of the command history.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#indexOfNextAdd">indexOfNextAdd</a></span></code></th>
<td class="colLast">
<div class="block">Index of the element to be added next.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#size">size</a></span></code></th>
<td class="colLast">
<div class="block">Maximum command history size.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="fields.inherited.from.class.hk.quantr.mxgraph.util.mxEventSource">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;hk.quantr.mxgraph.util.<a href="mxEventSource.html" title="class in hk.quantr.mxgraph.util">mxEventSource</a></h3>
<code><a href="mxEventSource.html#eventListeners">eventListeners</a>, <a href="mxEventSource.html#eventsEnabled">eventsEnabled</a>, <a href="mxEventSource.html#eventSource">eventSource</a></code></li>
</ul>
</li>
</ul>
</section>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">mxUndoManager</a></span>()</code></th>
<td class="colLast">
<div class="block">Constructs a new undo manager with a default history size.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(int)">mxUndoManager</a></span>&#8203;(int&nbsp;size)</code></th>
<td class="colLast">
<div class="block">Constructs a new undo manager for the specified size.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#canRedo()">canRedo</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns true if a redo is possible.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#canUndo()">canUndo</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns true if an undo is possible.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#clear()">clear</a></span>()</code></th>
<td class="colLast">
<div class="block">Clears the command history.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#isEmpty()">isEmpty</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#redo()">redo</a></span>()</code></th>
<td class="colLast">
<div class="block">Redoes the last change.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#trim()">trim</a></span>()</code></th>
<td class="colLast">
<div class="block">Removes all pending steps after indexOfNextAdd from the history,
 invoking die on each edit.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#undo()">undo</a></span>()</code></th>
<td class="colLast">
<div class="block">Undoes the last change.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#undoableEditHappened(hk.quantr.mxgraph.util.mxUndoableEdit)">undoableEditHappened</a></span>&#8203;(<a href="mxUndoableEdit.html" title="class in hk.quantr.mxgraph.util">mxUndoableEdit</a>&nbsp;undoableEdit)</code></th>
<td class="colLast">
<div class="block">Method to be called to add new undoable edits to the history.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.hk.quantr.mxgraph.util.mxEventSource">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;hk.quantr.mxgraph.util.<a href="mxEventSource.html" title="class in hk.quantr.mxgraph.util">mxEventSource</a></h3>
<code><a href="mxEventSource.html#addListener(java.lang.String,hk.quantr.mxgraph.util.mxEventSource.mxIEventListener)">addListener</a>, <a href="mxEventSource.html#fireEvent(hk.quantr.mxgraph.util.mxEventObject)">fireEvent</a>, <a href="mxEventSource.html#fireEvent(hk.quantr.mxgraph.util.mxEventObject,java.lang.Object)">fireEvent</a>, <a href="mxEventSource.html#getEventSource()">getEventSource</a>, <a href="mxEventSource.html#isEventsEnabled()">isEventsEnabled</a>, <a href="mxEventSource.html#removeListener(hk.quantr.mxgraph.util.mxEventSource.mxIEventListener)">removeListener</a>, <a href="mxEventSource.html#removeListener(hk.quantr.mxgraph.util.mxEventSource.mxIEventListener,java.lang.String)">removeListener</a>, <a href="mxEventSource.html#setEventsEnabled(boolean)">setEventsEnabled</a>, <a href="mxEventSource.html#setEventSource(java.lang.Object)">setEventSource</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a id="size">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>size</h4>
<pre>protected&nbsp;int size</pre>
<div class="block">Maximum command history size. 0 means unlimited history. Default is 100.</div>
</li>
</ul>
<a id="history">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>history</h4>
<pre>protected&nbsp;java.util.List&lt;<a href="mxUndoableEdit.html" title="class in hk.quantr.mxgraph.util">mxUndoableEdit</a>&gt; history</pre>
<div class="block">List that contains the steps of the command history.</div>
</li>
</ul>
<a id="indexOfNextAdd">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>indexOfNextAdd</h4>
<pre>protected&nbsp;int indexOfNextAdd</pre>
<div class="block">Index of the element to be added next.</div>
</li>
</ul>
</li>
</ul>
</section>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>mxUndoManager</h4>
<pre>public&nbsp;mxUndoManager()</pre>
<div class="block">Constructs a new undo manager with a default history size.</div>
</li>
</ul>
<a id="&lt;init&gt;(int)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>mxUndoManager</h4>
<pre>public&nbsp;mxUndoManager&#8203;(int&nbsp;size)</pre>
<div class="block">Constructs a new undo manager for the specified size.</div>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="isEmpty()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isEmpty</h4>
<pre class="methodSignature">public&nbsp;boolean&nbsp;isEmpty()</pre>
</li>
</ul>
<a id="clear()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clear</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;clear()</pre>
<div class="block">Clears the command history.</div>
</li>
</ul>
<a id="canUndo()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>canUndo</h4>
<pre class="methodSignature">public&nbsp;boolean&nbsp;canUndo()</pre>
<div class="block">Returns true if an undo is possible.</div>
</li>
</ul>
<a id="undo()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>undo</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;undo()</pre>
<div class="block">Undoes the last change.</div>
</li>
</ul>
<a id="canRedo()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>canRedo</h4>
<pre class="methodSignature">public&nbsp;boolean&nbsp;canRedo()</pre>
<div class="block">Returns true if a redo is possible.</div>
</li>
</ul>
<a id="redo()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>redo</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;redo()</pre>
<div class="block">Redoes the last change.</div>
</li>
</ul>
<a id="undoableEditHappened(hk.quantr.mxgraph.util.mxUndoableEdit)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>undoableEditHappened</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;undoableEditHappened&#8203;(<a href="mxUndoableEdit.html" title="class in hk.quantr.mxgraph.util">mxUndoableEdit</a>&nbsp;undoableEdit)</pre>
<div class="block">Method to be called to add new undoable edits to the history.</div>
</li>
</ul>
<a id="trim()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>trim</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;trim()</pre>
<div class="block">Removes all pending steps after indexOfNextAdd from the history,
 invoking die on each edit. This is called from undoableEditHappened.</div>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxUndoManager.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
<p class="legalCopy"><small><font size=1>Copyright (c) 2010 <a href="http://www.mxgraph.com/"
				target="_blank">Gaudenz Alder</a>. All rights reserved.</font></small></p>
</footer>
</body>
</html>
